#include "utils.h"
#include <stdio.h>

const char* const s_mem_error_msg =
	"Fatal Memory Allocation Error. Terminating Program\n";


void *
s_malloc (size_t size)
{
	void *temp;
	if ( (temp=malloc(size)) == NULL )
	  {
		fprintf (stderr, "%s", s_mem_error_msg);
		exit (1);
	  }
	else
		return (temp);
}



void
s_free (void *ptr)
{
	if (ptr != NULL)
	  {
		free (ptr);
	  }
}
